package com.sun.rowset;

import java.io.ObjectInputStream;
import java.sql.NClob;
import java.sql.RowId;
import java.sql.SQLFeatureNotSupportedException;
import java.sql.SQLXML;
import java.sql.Savepoint;
import java.sql.ParameterMetaData;
import java.sql.DatabaseMetaData;
import javax.sql.rowset.RowSetWarning;
import java.net.URL;
import java.sql.Array;
import java.sql.Clob;
import java.sql.Blob;
import java.sql.Ref;
import java.sql.Statement;
import java.sql.SQLWarning;
import java.math.BigDecimal;
import java.util.Calendar;
import java.io.Reader;
import java.sql.Timestamp;
import java.sql.Time;
import java.sql.Date;
import java.io.InputStream;
import java.util.Map;
import javax.naming.NamingException;
import javax.naming.InitialContext;
import javax.sql.DataSource;
import java.sql.DriverManager;
import javax.sql.RowSetMetaData;
import java.sql.SQLException;
import java.io.IOException;
import java.util.Vector;
import java.sql.ResultSetMetaData;
import javax.sql.rowset.RowSetMetaDataImpl;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.Connection;
import javax.sql.rowset.Joinable;
import javax.sql.rowset.JdbcRowSet;
import javax.sql.rowset.BaseRowSet;

public class JdbcRowSetImpl extends BaseRowSet implements JdbcRowSet, Joinable
{
    private Connection conn;
    private PreparedStatement ps;
    private ResultSet rs;
    private RowSetMetaDataImpl rowsMD;
    private ResultSetMetaData resMD;
    private Vector<Integer> iMatchColumns;
    private Vector<String> strMatchColumns;
    protected transient JdbcRowSetResourceBundle resBundle;
    static final long serialVersionUID = -3591946023893483003L;
    
    public JdbcRowSetImpl() {
        this.conn = null;
        this.ps = null;
        this.rs = null;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
        this.initParams();
        try {
            this.setShowDeleted(false);
        }
        catch (SQLException ex) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setshowdeleted").toString() + ex.getLocalizedMessage());
        }
        try {
            this.setQueryTimeout(0);
        }
        catch (SQLException ex2) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setquerytimeout").toString() + ex2.getLocalizedMessage());
        }
        try {
            this.setMaxRows(0);
        }
        catch (SQLException ex3) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setmaxrows").toString() + ex3.getLocalizedMessage());
        }
        try {
            this.setMaxFieldSize(0);
        }
        catch (SQLException ex4) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setmaxfieldsize").toString() + ex4.getLocalizedMessage());
        }
        try {
            this.setEscapeProcessing(true);
        }
        catch (SQLException ex5) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setescapeprocessing").toString() + ex5.getLocalizedMessage());
        }
        try {
            this.setConcurrency(1008);
        }
        catch (SQLException ex6) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setconcurrency").toString() + ex6.getLocalizedMessage());
        }
        this.setTypeMap(null);
        try {
            this.setType(1004);
        }
        catch (SQLException ex7) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.settype").toString() + ex7.getLocalizedMessage());
        }
        this.setReadOnly(true);
        try {
            this.setTransactionIsolation(2);
        }
        catch (SQLException ex8) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.settransactionisolation").toString() + ex8.getLocalizedMessage());
        }
        this.iMatchColumns = new Vector(10);
        for (int i = 0; i < 10; ++i) {
            this.iMatchColumns.add(i, Integer.valueOf(-1));
        }
        this.strMatchColumns = new Vector(10);
        for (int j = 0; j < 10; ++j) {
            this.strMatchColumns.add(j, null);
        }
    }
    
    public JdbcRowSetImpl(Connection conn) throws SQLException {
        this.conn = conn;
        this.ps = null;
        this.rs = null;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
        this.initParams();
        this.setShowDeleted(false);
        this.setQueryTimeout(0);
        this.setMaxRows(0);
        this.setMaxFieldSize(0);
        this.setParams();
        this.setReadOnly(true);
        this.setTransactionIsolation(2);
        this.setEscapeProcessing(true);
        this.setTypeMap(null);
        this.iMatchColumns = new Vector(10);
        for (int i = 0; i < 10; ++i) {
            this.iMatchColumns.add(i, Integer.valueOf(-1));
        }
        this.strMatchColumns = new Vector(10);
        for (int j = 0; j < 10; ++j) {
            this.strMatchColumns.add(j, null);
        }
    }
    
    public JdbcRowSetImpl(String url, String username, String password) throws SQLException {
        this.conn = null;
        this.ps = null;
        this.rs = null;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
        this.initParams();
        this.setUsername(username);
        this.setPassword(password);
        this.setUrl(url);
        this.setShowDeleted(false);
        this.setQueryTimeout(0);
        this.setMaxRows(0);
        this.setMaxFieldSize(0);
        this.setParams();
        this.setReadOnly(true);
        this.setTransactionIsolation(2);
        this.setEscapeProcessing(true);
        this.setTypeMap(null);
        this.iMatchColumns = new Vector(10);
        for (int i = 0; i < 10; ++i) {
            this.iMatchColumns.add(i, Integer.valueOf(-1));
        }
        this.strMatchColumns = new Vector(10);
        for (int j = 0; j < 10; ++j) {
            this.strMatchColumns.add(j, null);
        }
    }
    
    public JdbcRowSetImpl(ResultSet rs) throws SQLException {
        this.conn = null;
        this.ps = null;
        this.rs = rs;
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
        this.initParams();
        this.setShowDeleted(false);
        this.setQueryTimeout(0);
        this.setMaxRows(0);
        this.setMaxFieldSize(0);
        this.setParams();
        this.setReadOnly(true);
        this.setTransactionIsolation(2);
        this.setEscapeProcessing(true);
        this.setTypeMap(null);
        this.resMD = this.rs.getMetaData();
        this.initMetaData(this.rowsMD = new RowSetMetaDataImpl(), this.resMD);
        this.iMatchColumns = new Vector(10);
        for (int i = 0; i < 10; ++i) {
            this.iMatchColumns.add(i, Integer.valueOf(-1));
        }
        this.strMatchColumns = new Vector(10);
        for (int j = 0; j < 10; ++j) {
            this.strMatchColumns.add(j, null);
        }
    }
    
    protected void initMetaData(RowSetMetaData rowSetMetaData, ResultSetMetaData resultSetMetaData) throws SQLException {
        int columnCount = resultSetMetaData.getColumnCount();
        rowSetMetaData.setColumnCount(columnCount);
        for (int i = 1; i <= columnCount; ++i) {
            rowSetMetaData.setAutoIncrement(i, resultSetMetaData.isAutoIncrement(i));
            rowSetMetaData.setCaseSensitive(i, resultSetMetaData.isCaseSensitive(i));
            rowSetMetaData.setCurrency(i, resultSetMetaData.isCurrency(i));
            rowSetMetaData.setNullable(i, resultSetMetaData.isNullable(i));
            rowSetMetaData.setSigned(i, resultSetMetaData.isSigned(i));
            rowSetMetaData.setSearchable(i, resultSetMetaData.isSearchable(i));
            rowSetMetaData.setColumnDisplaySize(i, resultSetMetaData.getColumnDisplaySize(i));
            rowSetMetaData.setColumnLabel(i, resultSetMetaData.getColumnLabel(i));
            rowSetMetaData.setColumnName(i, resultSetMetaData.getColumnName(i));
            rowSetMetaData.setSchemaName(i, resultSetMetaData.getSchemaName(i));
            rowSetMetaData.setPrecision(i, resultSetMetaData.getPrecision(i));
            rowSetMetaData.setScale(i, resultSetMetaData.getScale(i));
            rowSetMetaData.setTableName(i, resultSetMetaData.getTableName(i));
            rowSetMetaData.setCatalogName(i, resultSetMetaData.getCatalogName(i));
            rowSetMetaData.setColumnType(i, resultSetMetaData.getColumnType(i));
            rowSetMetaData.setColumnTypeName(i, resultSetMetaData.getColumnTypeName(i));
        }
    }
    
    protected void checkState() throws SQLException {
        if (this.conn == null && this.ps == null && this.rs == null) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.invalstate").toString());
        }
        return;
    }
    
    @Override
    public void execute() throws SQLException {
        this.prepare();
        this.setProperties(this.ps);
        this.decodeParams(this.getParams(), this.ps);
        this.rs = this.ps.executeQuery();
        this.notifyRowSetChanged();
    }
    
    protected void setProperties(PreparedStatement preparedStatement) throws SQLException {
        try {
            preparedStatement.setEscapeProcessing(this.getEscapeProcessing());
        }
        catch (SQLException ex) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setescapeprocessing").toString() + ex.getLocalizedMessage());
        }
        try {
            preparedStatement.setMaxFieldSize(this.getMaxFieldSize());
        }
        catch (SQLException ex2) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setmaxfieldsize").toString() + ex2.getLocalizedMessage());
        }
        try {
            preparedStatement.setMaxRows(this.getMaxRows());
        }
        catch (SQLException ex3) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setmaxrows").toString() + ex3.getLocalizedMessage());
        }
        try {
            preparedStatement.setQueryTimeout(this.getQueryTimeout());
        }
        catch (SQLException ex4) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.setquerytimeout").toString() + ex4.getLocalizedMessage());
        }
    }
    
    private Connection connect() throws SQLException {
        if (this.conn != null) {
            return this.conn;
        }
        if (this.getDataSourceName() != null) {
            try {
                DataSource dataSource = (DataSource)new InitialContext().lookup(this.getDataSourceName());
                if (this.getUsername() != null && !this.getUsername().equals("")) {
                    return dataSource.getConnection(this.getUsername(), this.getPassword());
                }
                return dataSource.getConnection();
            }
            catch (NamingException ex) {
                throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.connect").toString());
            }
        }
        else {
            if (this.getUrl() != null) {
                return DriverManager.getConnection(this.getUrl(), this.getUsername(), this.getPassword());
            }
            return null;
        }
    }
    
    protected PreparedStatement prepare() throws SQLException {
        this.conn = this.connect();
        try {
            Map<String, Class<?>> typeMap = this.getTypeMap();
            if (typeMap != null) {
                this.conn.setTypeMap(typeMap);
            }
            this.ps = this.conn.prepareStatement(this.getCommand(), 1004, 1008);
        }
        catch (SQLException ex) {
            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.prepare").toString() + ex.getLocalizedMessage());
            if (this.ps != null) {
                this.ps.close();
            }
            if (this.conn != null) {
                this.conn.close();
            }
            throw new SQLException(ex.getMessage());
        }
        return this.ps;
    }
    
    private void decodeParams(Object[] array, PreparedStatement preparedStatement) throws SQLException {
        for (int i = 0; i < array.length; ++i) {
            if ((array[i] instanceof Object[])) {
                Object[] array2 = (Object[])(Object[])array[i];
                if (array2.length == 2) {
                    if (array2[0] == null) {
                        preparedStatement.setNull(i + 1, (int)array2[1]);
                    }
                    else if (array2[0] instanceof Date || array2[0] instanceof Time || array2[0] instanceof Timestamp) {
                        System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.detecteddate"));
                        if ((array2[1] instanceof Calendar)) {
                            System.err.println(this.resBundle.handleGetObject("jdbcrowsetimpl.detectedcalendar"));
                            preparedStatement.setDate(i + 1, (Date)array2[0], (Calendar)array2[1]);
                        }
                        else {
                            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.paramtype").toString());
                        }
                    }
                    else if ((array2[0] instanceof Reader)) {
                        preparedStatement.setCharacterStream(i + 1, (Reader)array2[0], (int)array2[1]);
                    }
                    else if ((array2[1] instanceof Integer)) {
                        preparedStatement.setObject(i + 1, array2[0], (int)array2[1]);
                    }
                }
                else if (array2.length == 3) {
                    if (array2[0] == null) {
                        preparedStatement.setNull(i + 1, (int)array2[1], (String)array2[2]);
                    }
                    else {
                        if ((array2[0] instanceof InputStream)) {
                            switch ((int)array2[2]) {
                                case 0: {
                                    preparedStatement.setUnicodeStream(i + 1, (InputStream)array2[0], (int)array2[1]);
                                    break;
                                }
                                case 1: {
                                    preparedStatement.setBinaryStream(i + 1, (InputStream)array2[0], (int)array2[1]);
                                    break;
                                }
                                case 2: {
                                    preparedStatement.setAsciiStream(i + 1, (InputStream)array2[0], (int)array2[1]);
                                    break;
                                }
                                default: {
                                    throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.paramtype").toString());
                                }
                            }
                        }
                        if (array2[1] instanceof Integer && array2[2] instanceof Integer) {
                            preparedStatement.setObject(i + 1, array2[0], (int)array2[1], (int)array2[2]);
                        }
                        else {
                            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.paramtype").toString());
                        }
                    }
                }
                else {
                    preparedStatement.setObject(i + 1, array[i]);
                }
            }
            else {
                preparedStatement.setObject(i + 1, array[i]);
            }
        }
    }
    
    @Override
    public boolean next() throws SQLException {
        this.checkState();
        int next = this.rs.next();
        this.notifyCursorMoved();
        return next;
    }
    
    @Override
    public void close() throws SQLException {
        if (this.rs != null) {
            this.rs.close();
        }
        if (this.ps != null) {
            this.ps.close();
        }
        if (this.conn != null) {
            this.conn.close();
        }
    }
    
    @Override
    public boolean wasNull() throws SQLException {
        this.checkState();
        return this.rs.wasNull();
    }
    
    @Override
    public String getString(int n) throws SQLException {
        this.checkState();
        return this.rs.getString(n);
    }
    
    @Override
    public boolean getBoolean(int n) throws SQLException {
        this.checkState();
        return this.rs.getBoolean(n);
    }
    
    @Override
    public byte getByte(int n) throws SQLException {
        this.checkState();
        return this.rs.getByte(n);
    }
    
    @Override
    public short getShort(int n) throws SQLException {
        this.checkState();
        return this.rs.getShort(n);
    }
    
    @Override
    public int getInt(int n) throws SQLException {
        this.checkState();
        return this.rs.getInt(n);
    }
    
    @Override
    public long getLong(int n) throws SQLException {
        this.checkState();
        return this.rs.getLong(n);
    }
    
    @Override
    public float getFloat(int n) throws SQLException {
        this.checkState();
        return this.rs.getFloat(n);
    }
    
    @Override
    public double getDouble(int n) throws SQLException {
        this.checkState();
        return this.rs.getDouble(n);
    }
    
    @Deprecated
    @Override
    public BigDecimal getBigDecimal(int n, int n2) throws SQLException {
        this.checkState();
        return this.rs.getBigDecimal(n, n2);
    }
    
    @Override
    public byte[] getBytes(int n) throws SQLException {
        this.checkState();
        return this.rs.getBytes(n);
    }
    
    @Override
    public Date getDate(int n) throws SQLException {
        this.checkState();
        return this.rs.getDate(n);
    }
    
    @Override
    public Time getTime(int n) throws SQLException {
        this.checkState();
        return this.rs.getTime(n);
    }
    
    @Override
    public Timestamp getTimestamp(int n) throws SQLException {
        this.checkState();
        return this.rs.getTimestamp(n);
    }
    
    @Override
    public InputStream getAsciiStream(int n) throws SQLException {
        this.checkState();
        return this.rs.getAsciiStream(n);
    }
    
    @Deprecated
    @Override
    public InputStream getUnicodeStream(int n) throws SQLException {
        this.checkState();
        return this.rs.getUnicodeStream(n);
    }
    
    @Override
    public InputStream getBinaryStream(int n) throws SQLException {
        this.checkState();
        return this.rs.getBinaryStream(n);
    }
    
    @Override
    public String getString(String s) throws SQLException {
        return this.getString(this.findColumn(s));
    }
    
    @Override
    public boolean getBoolean(String s) throws SQLException {
        return this.getBoolean(this.findColumn(s));
    }
    
    @Override
    public byte getByte(String s) throws SQLException {
        return this.getByte(this.findColumn(s));
    }
    
    @Override
    public short getShort(String s) throws SQLException {
        return this.getShort(this.findColumn(s));
    }
    
    @Override
    public int getInt(String s) throws SQLException {
        return this.getInt(this.findColumn(s));
    }
    
    @Override
    public long getLong(String s) throws SQLException {
        return this.getLong(this.findColumn(s));
    }
    
    @Override
    public float getFloat(String s) throws SQLException {
        return this.getFloat(this.findColumn(s));
    }
    
    @Override
    public double getDouble(String s) throws SQLException {
        return this.getDouble(this.findColumn(s));
    }
    
    @Deprecated
    @Override
    public BigDecimal getBigDecimal(String s, int n) throws SQLException {
        return this.getBigDecimal(this.findColumn(s), n);
    }
    
    @Override
    public byte[] getBytes(String s) throws SQLException {
        return this.getBytes(this.findColumn(s));
    }
    
    @Override
    public Date getDate(String s) throws SQLException {
        return this.getDate(this.findColumn(s));
    }
    
    @Override
    public Time getTime(String s) throws SQLException {
        return this.getTime(this.findColumn(s));
    }
    
    @Override
    public Timestamp getTimestamp(String s) throws SQLException {
        return this.getTimestamp(this.findColumn(s));
    }
    
    @Override
    public InputStream getAsciiStream(String s) throws SQLException {
        return this.getAsciiStream(this.findColumn(s));
    }
    
    @Deprecated
    @Override
    public InputStream getUnicodeStream(String s) throws SQLException {
        return this.getUnicodeStream(this.findColumn(s));
    }
    
    @Override
    public InputStream getBinaryStream(String s) throws SQLException {
        return this.getBinaryStream(this.findColumn(s));
    }
    
    @Override
    public SQLWarning getWarnings() throws SQLException {
        this.checkState();
        return this.rs.getWarnings();
    }
    
    @Override
    public void clearWarnings() throws SQLException {
        this.checkState();
        this.rs.clearWarnings();
    }
    
    @Override
    public String getCursorName() throws SQLException {
        this.checkState();
        return this.rs.getCursorName();
    }
    
    @Override
    public ResultSetMetaData getMetaData() throws SQLException {
        this.checkState();
        try {
            this.checkState();
        }
        catch (SQLException ex) {
            this.prepare();
            return this.ps.getMetaData();
        }
        return this.rs.getMetaData();
    }
    
    @Override
    public Object getObject(int n) throws SQLException {
        this.checkState();
        return this.rs.getObject(n);
    }
    
    @Override
    public Object getObject(String s) throws SQLException {
        return this.getObject(this.findColumn(s));
    }
    
    @Override
    public int findColumn(String s) throws SQLException {
        this.checkState();
        return this.rs.findColumn(s);
    }
    
    @Override
    public Reader getCharacterStream(int n) throws SQLException {
        this.checkState();
        return this.rs.getCharacterStream(n);
    }
    
    @Override
    public Reader getCharacterStream(String s) throws SQLException {
        return this.getCharacterStream(this.findColumn(s));
    }
    
    @Override
    public BigDecimal getBigDecimal(int n) throws SQLException {
        this.checkState();
        return this.rs.getBigDecimal(n);
    }
    
    @Override
    public BigDecimal getBigDecimal(String s) throws SQLException {
        return this.getBigDecimal(this.findColumn(s));
    }
    
    @Override
    public boolean isBeforeFirst() throws SQLException {
        this.checkState();
        return this.rs.isBeforeFirst();
    }
    
    @Override
    public boolean isAfterLast() throws SQLException {
        this.checkState();
        return this.rs.isAfterLast();
    }
    
    @Override
    public boolean isFirst() throws SQLException {
        this.checkState();
        return this.rs.isFirst();
    }
    
    @Override
    public boolean isLast() throws SQLException {
        this.checkState();
        return this.rs.isLast();
    }
    
    @Override
    public void beforeFirst() throws SQLException {
        this.checkState();
        this.rs.beforeFirst();
        this.notifyCursorMoved();
    }
    
    @Override
    public void afterLast() throws SQLException {
        this.checkState();
        this.rs.afterLast();
        this.notifyCursorMoved();
    }
    
    @Override
    public boolean first() throws SQLException {
        this.checkState();
        int first = this.rs.first();
        this.notifyCursorMoved();
        return first;
    }
    
    @Override
    public boolean last() throws SQLException {
        this.checkState();
        int last = this.rs.last();
        this.notifyCursorMoved();
        return last;
    }
    
    @Override
    public int getRow() throws SQLException {
        this.checkState();
        return this.rs.getRow();
    }
    
    @Override
    public boolean absolute(int n) throws SQLException {
        this.checkState();
        int absolute = this.rs.absolute(n);
        this.notifyCursorMoved();
        return absolute;
    }
    
    @Override
    public boolean relative(int n) throws SQLException {
        this.checkState();
        int relative = this.rs.relative(n);
        this.notifyCursorMoved();
        return relative;
    }
    
    @Override
    public boolean previous() throws SQLException {
        this.checkState();
        int previous = this.rs.previous();
        this.notifyCursorMoved();
        return previous;
    }
    
    @Override
    public void setFetchDirection(int fetchDirection) throws SQLException {
        this.checkState();
        this.rs.setFetchDirection(fetchDirection);
    }
    
    @Override
    public int getFetchDirection() throws SQLException {
        try {
            this.checkState();
        }
        catch (SQLException ex) {
            super.getFetchDirection();
        }
        return this.rs.getFetchDirection();
    }
    
    @Override
    public void setFetchSize(int fetchSize) throws SQLException {
        this.checkState();
        this.rs.setFetchSize(fetchSize);
    }
    
    @Override
    public int getType() throws SQLException {
        try {
            this.checkState();
        }
        catch (SQLException ex) {
            return super.getType();
        }
        if (this.rs == null) {
            return super.getType();
        }
        return this.rs.getType();
    }
    
    @Override
    public int getConcurrency() throws SQLException {
        try {
            this.checkState();
        }
        catch (SQLException ex) {
            super.getConcurrency();
        }
        return this.rs.getConcurrency();
    }
    
    @Override
    public boolean rowUpdated() throws SQLException {
        this.checkState();
        return this.rs.rowUpdated();
    }
    
    @Override
    public boolean rowInserted() throws SQLException {
        this.checkState();
        return this.rs.rowInserted();
    }
    
    @Override
    public boolean rowDeleted() throws SQLException {
        this.checkState();
        return this.rs.rowDeleted();
    }
    
    @Override
    public void updateNull(int n) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateNull(n);
    }
    
    @Override
    public void updateBoolean(int n, boolean b) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateBoolean(n, b);
    }
    
    @Override
    public void updateByte(int n, byte b) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateByte(n, b);
    }
    
    @Override
    public void updateShort(int n, short n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateShort(n, n2);
    }
    
    @Override
    public void updateInt(int n, int n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateInt(n, n2);
    }
    
    @Override
    public void updateLong(int n, long n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateLong(n, n2);
    }
    
    @Override
    public void updateFloat(int n, float n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateFloat(n, n2);
    }
    
    @Override
    public void updateDouble(int n, double n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateDouble(n, n2);
    }
    
    @Override
    public void updateBigDecimal(int n, BigDecimal bigDecimal) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateBigDecimal(n, bigDecimal);
    }
    
    @Override
    public void updateString(int n, String s) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateString(n, s);
    }
    
    @Override
    public void updateBytes(int n, byte[] array) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateBytes(n, array);
    }
    
    @Override
    public void updateDate(int n, Date date) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateDate(n, date);
    }
    
    @Override
    public void updateTime(int n, Time time) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateTime(n, time);
    }
    
    @Override
    public void updateTimestamp(int n, Timestamp timestamp) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateTimestamp(n, timestamp);
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream, int n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateAsciiStream(n, inputStream, n2);
    }
    
    @Override
    public void updateBinaryStream(int n, InputStream inputStream, int n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateBinaryStream(n, inputStream, n2);
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader, int n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateCharacterStream(n, reader, n2);
    }
    
    @Override
    public void updateObject(int n, Object o, int n2) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateObject(n, o, n2);
    }
    
    @Override
    public void updateObject(int n, Object o) throws SQLException {
        this.checkState();
        this.checkTypeConcurrency();
        this.rs.updateObject(n, o);
    }
    
    @Override
    public void updateNull(String s) throws SQLException {
        this.updateNull(this.findColumn(s));
    }
    
    @Override
    public void updateBoolean(String s, boolean b) throws SQLException {
        this.updateBoolean(this.findColumn(s), b);
    }
    
    @Override
    public void updateByte(String s, byte b) throws SQLException {
        this.updateByte(this.findColumn(s), b);
    }
    
    @Override
    public void updateShort(String s, short n) throws SQLException {
        this.updateShort(this.findColumn(s), n);
    }
    
    @Override
    public void updateInt(String s, int n) throws SQLException {
        this.updateInt(this.findColumn(s), n);
    }
    
    @Override
    public void updateLong(String s, long n) throws SQLException {
        this.updateLong(this.findColumn(s), n);
    }
    
    @Override
    public void updateFloat(String s, float n) throws SQLException {
        this.updateFloat(this.findColumn(s), n);
    }
    
    @Override
    public void updateDouble(String s, double n) throws SQLException {
        this.updateDouble(this.findColumn(s), n);
    }
    
    @Override
    public void updateBigDecimal(String s, BigDecimal bigDecimal) throws SQLException {
        this.updateBigDecimal(this.findColumn(s), bigDecimal);
    }
    
    @Override
    public void updateString(String s, String s2) throws SQLException {
        this.updateString(this.findColumn(s), s2);
    }
    
    @Override
    public void updateBytes(String s, byte[] array) throws SQLException {
        this.updateBytes(this.findColumn(s), array);
    }
    
    @Override
    public void updateDate(String s, Date date) throws SQLException {
        this.updateDate(this.findColumn(s), date);
    }
    
    @Override
    public void updateTime(String s, Time time) throws SQLException {
        this.updateTime(this.findColumn(s), time);
    }
    
    @Override
    public void updateTimestamp(String s, Timestamp timestamp) throws SQLException {
        this.updateTimestamp(this.findColumn(s), timestamp);
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream, int n) throws SQLException {
        this.updateAsciiStream(this.findColumn(s), inputStream, n);
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream, int n) throws SQLException {
        this.updateBinaryStream(this.findColumn(s), inputStream, n);
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader, int n) throws SQLException {
        this.updateCharacterStream(this.findColumn(s), reader, n);
    }
    
    @Override
    public void updateObject(String s, Object o, int n) throws SQLException {
        this.updateObject(this.findColumn(s), o, n);
    }
    
    @Override
    public void updateObject(String s, Object o) throws SQLException {
        this.updateObject(this.findColumn(s), o);
    }
    
    @Override
    public void insertRow() throws SQLException {
        this.checkState();
        this.rs.insertRow();
        this.notifyRowChanged();
    }
    
    @Override
    public void updateRow() throws SQLException {
        this.checkState();
        this.rs.updateRow();
        this.notifyRowChanged();
    }
    
    @Override
    public void deleteRow() throws SQLException {
        this.checkState();
        this.rs.deleteRow();
        this.notifyRowChanged();
    }
    
    @Override
    public void refreshRow() throws SQLException {
        this.checkState();
        this.rs.refreshRow();
    }
    
    @Override
    public void cancelRowUpdates() throws SQLException {
        this.checkState();
        this.rs.cancelRowUpdates();
        this.notifyRowChanged();
    }
    
    @Override
    public void moveToInsertRow() throws SQLException {
        this.checkState();
        this.rs.moveToInsertRow();
    }
    
    @Override
    public void moveToCurrentRow() throws SQLException {
        this.checkState();
        this.rs.moveToCurrentRow();
    }
    
    @Override
    public Statement getStatement() throws SQLException {
        if (this.rs != null) {
            return this.rs.getStatement();
        }
        return null;
    }
    
    @Override
    public Object getObject(int n, Map<String, Class<?>> map) throws SQLException {
        this.checkState();
        return this.rs.getObject(n, map);
    }
    
    @Override
    public Ref getRef(int n) throws SQLException {
        this.checkState();
        return this.rs.getRef(n);
    }
    
    @Override
    public Blob getBlob(int n) throws SQLException {
        this.checkState();
        return this.rs.getBlob(n);
    }
    
    @Override
    public Clob getClob(int n) throws SQLException {
        this.checkState();
        return this.rs.getClob(n);
    }
    
    @Override
    public Array getArray(int n) throws SQLException {
        this.checkState();
        return this.rs.getArray(n);
    }
    
    @Override
    public Object getObject(String s, Map<String, Class<?>> map) throws SQLException {
        return this.getObject(this.findColumn(s), map);
    }
    
    @Override
    public Ref getRef(String s) throws SQLException {
        return this.getRef(this.findColumn(s));
    }
    
    @Override
    public Blob getBlob(String s) throws SQLException {
        return this.getBlob(this.findColumn(s));
    }
    
    @Override
    public Clob getClob(String s) throws SQLException {
        return this.getClob(this.findColumn(s));
    }
    
    @Override
    public Array getArray(String s) throws SQLException {
        return this.getArray(this.findColumn(s));
    }
    
    @Override
    public Date getDate(int n, Calendar calendar) throws SQLException {
        this.checkState();
        return this.rs.getDate(n, calendar);
    }
    
    @Override
    public Date getDate(String s, Calendar calendar) throws SQLException {
        return this.getDate(this.findColumn(s), calendar);
    }
    
    @Override
    public Time getTime(int n, Calendar calendar) throws SQLException {
        this.checkState();
        return this.rs.getTime(n, calendar);
    }
    
    @Override
    public Time getTime(String s, Calendar calendar) throws SQLException {
        return this.getTime(this.findColumn(s), calendar);
    }
    
    @Override
    public Timestamp getTimestamp(int n, Calendar calendar) throws SQLException {
        this.checkState();
        return this.rs.getTimestamp(n, calendar);
    }
    
    @Override
    public Timestamp getTimestamp(String s, Calendar calendar) throws SQLException {
        return this.getTimestamp(this.findColumn(s), calendar);
    }
    
    @Override
    public void updateRef(int n, Ref ref) throws SQLException {
        this.checkState();
        this.rs.updateRef(n, ref);
    }
    
    @Override
    public void updateRef(String s, Ref ref) throws SQLException {
        this.updateRef(this.findColumn(s), ref);
    }
    
    @Override
    public void updateClob(int n, Clob clob) throws SQLException {
        this.checkState();
        this.rs.updateClob(n, clob);
    }
    
    @Override
    public void updateClob(String s, Clob clob) throws SQLException {
        this.updateClob(this.findColumn(s), clob);
    }
    
    @Override
    public void updateBlob(int n, Blob blob) throws SQLException {
        this.checkState();
        this.rs.updateBlob(n, blob);
    }
    
    @Override
    public void updateBlob(String s, Blob blob) throws SQLException {
        this.updateBlob(this.findColumn(s), blob);
    }
    
    @Override
    public void updateArray(int n, Array array) throws SQLException {
        this.checkState();
        this.rs.updateArray(n, array);
    }
    
    @Override
    public void updateArray(String s, Array array) throws SQLException {
        this.updateArray(this.findColumn(s), array);
    }
    
    @Override
    public URL getURL(int n) throws SQLException {
        this.checkState();
        return this.rs.getURL(n);
    }
    
    @Override
    public URL getURL(String s) throws SQLException {
        return this.getURL(this.findColumn(s));
    }
    
    @Override
    public RowSetWarning getRowSetWarnings() throws SQLException {
        return null;
    }
    
    @Override
    public void unsetMatchColumn(int[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (array[i] != Integer.parseInt(((Integer)this.iMatchColumns.get(i)).toString())) {
                throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.matchcols").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.iMatchColumns.set(j, Integer.valueOf(-1));
        }
    }
    
    @Override
    public void unsetMatchColumn(String[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (!array[i].equals(this.strMatchColumns.get(i))) {
                throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.matchcols").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.strMatchColumns.set(j, null);
        }
    }
    
    @Override
    public String[] getMatchColumnNames() throws SQLException {
        String[] anArray = new String[this.strMatchColumns.size()];
        if (this.strMatchColumns.get(0) == null) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.setmatchcols").toString());
        }
        this.strMatchColumns.copyInto(anArray);
        return anArray;
    }
    
    @Override
    public int[] getMatchColumnIndexes() throws SQLException {
        Integer[] anArray = new Integer[this.iMatchColumns.size()];
        int[] array = new int[this.iMatchColumns.size()];
        if ((int)this.iMatchColumns.get(0) == -1) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.setmatchcols").toString());
        }
        this.iMatchColumns.copyInto(anArray);
        for (int i = 0; i < anArray.length; ++i) {
            array[i] = (int)anArray[i];
        }
        return array;
    }
    
    @Override
    public void setMatchColumn(int[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (array[i] < 0) {
                throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.matchcols1").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.iMatchColumns.add(j, Integer.valueOf(array[j]));
        }
    }
    
    @Override
    public void setMatchColumn(String[] array) throws SQLException {
        int i = 0;
        while (i < array.length) {
            if (array[i] == null || array[i].equals("")) {
                throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.matchcols2").toString());
            }
            ++i;
        }
        for (int j = 0; j < array.length; ++j) {
            this.strMatchColumns.add(j, array[j]);
        }
    }
    
    @Override
    public void setMatchColumn(int i) throws SQLException {
        if (i < 0) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.matchcols1").toString());
        }
        this.iMatchColumns.set(0, Integer.valueOf(i));
        return;
    }
    
    @Override
    public void setMatchColumn(String trim) throws SQLException {
        if (trim == null || (trim = trim.trim()).equals("")) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.matchcols2").toString());
        }
        this.strMatchColumns.set(0, trim);
        return;
    }
    
    @Override
    public void unsetMatchColumn(int i) throws SQLException {
        if (!((Integer)this.iMatchColumns.get(0)).equals(Integer.valueOf(i))) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.unsetmatch").toString());
        }
        if (this.strMatchColumns.get(0) != null) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.usecolname").toString());
        }
        this.iMatchColumns.set(0, Integer.valueOf(-1));
        return;
    }
    
    @Override
    public void unsetMatchColumn(String trim) throws SQLException {
        trim = trim.trim();
        if (!((String)this.strMatchColumns.get(0)).equals(trim)) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.unsetmatch").toString());
        }
        if ((int)this.iMatchColumns.get(0) > 0) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.usecolid").toString());
        }
        this.strMatchColumns.set(0, null);
        return;
    }
    
    public DatabaseMetaData getDatabaseMetaData() throws SQLException {
        return this.connect().getMetaData();
    }
    
    public ParameterMetaData getParameterMetaData() throws SQLException {
        this.prepare();
        return this.ps.getParameterMetaData();
    }
    
    @Override
    public void commit() throws SQLException {
        this.conn.commit();
        if (this.conn.getHoldability() != 1) {
            this.rs = null;
        }
    }
    
    @Override
    public void setAutoCommit(boolean b) throws SQLException {
        if (this.conn != null) {
            this.conn.setAutoCommit(b);
        }
        else {
            (this.conn = this.connect()).setAutoCommit(b);
        }
    }
    
    @Override
    public boolean getAutoCommit() throws SQLException {
        return this.conn.getAutoCommit();
    }
    
    @Override
    public void rollback() throws SQLException {
        this.conn.rollback();
        this.rs = null;
    }
    
    @Override
    public void rollback(Savepoint savepoint) throws SQLException {
        this.conn.rollback(savepoint);
    }
    
    protected void setParams() throws SQLException {
        if (this.rs == null) {
            this.setType(1004);
            this.setConcurrency(1008);
        }
        else {
            this.setType(this.rs.getType());
            this.setConcurrency(this.rs.getConcurrency());
        }
    }
    
    private void checkTypeConcurrency() throws SQLException {
        if (this.rs.getType() == 1003 || this.rs.getConcurrency() == 1007) {
            throw new SQLException(this.resBundle.handleGetObject("jdbcrowsetimpl.resnotupd").toString());
        }
        return;
    }
    
    protected Connection getConnection() {
        return this.conn;
    }
    
    protected void setConnection(Connection conn) {
        this.conn = conn;
    }
    
    protected PreparedStatement getPreparedStatement() {
        return this.ps;
    }
    
    protected void setPreparedStatement(PreparedStatement ps) {
        this.ps = ps;
    }
    
    protected ResultSet getResultSet() throws SQLException {
        this.checkState();
        return this.rs;
    }
    
    protected void setResultSet(ResultSet rs) {
        this.rs = rs;
    }
    
    @Override
    public void setCommand(String command) throws SQLException {
        if (this.getCommand() != null) {
            if (!this.getCommand().equals(command)) {
                super.setCommand(command);
                this.ps = null;
                this.rs = null;
            }
        }
        else {
            super.setCommand(command);
        }
    }
    
    @Override
    public void setDataSourceName(String dataSourceName) throws SQLException {
        if (this.getDataSourceName() != null) {
            if (!this.getDataSourceName().equals(dataSourceName)) {
                super.setDataSourceName(dataSourceName);
                this.conn = null;
                this.ps = null;
                this.rs = null;
            }
        }
        else {
            super.setDataSourceName(dataSourceName);
        }
    }
    
    @Override
    public void setUrl(String url) throws SQLException {
        if (this.getUrl() != null) {
            if (!this.getUrl().equals(url)) {
                super.setUrl(url);
                this.conn = null;
                this.ps = null;
                this.rs = null;
            }
        }
        else {
            super.setUrl(url);
        }
    }
    
    @Override
    public void setUsername(String username) {
        if (this.getUsername() != null) {
            if (!this.getUsername().equals(username)) {
                super.setUsername(username);
                this.conn = null;
                this.ps = null;
                this.rs = null;
            }
        }
        else {
            super.setUsername(username);
        }
    }
    
    @Override
    public void setPassword(String password) {
        if (this.getPassword() != null) {
            if (!this.getPassword().equals(password)) {
                super.setPassword(password);
                this.conn = null;
                this.ps = null;
                this.rs = null;
            }
        }
        else {
            super.setPassword(password);
        }
    }
    
    @Override
    public void setType(int type) throws SQLException {
        int type2;
        try {
            type2 = this.getType();
        }
        catch (SQLException ex) {
            type2 = 0;
        }
        if (type2 != type) {
            super.setType(type);
        }
    }
    
    @Override
    public void setConcurrency(int concurrency) throws SQLException {
        int concurrency2;
        try {
            concurrency2 = this.getConcurrency();
        }
        catch (NullPointerException ex) {
            concurrency2 = 0;
        }
        if (concurrency2 != concurrency) {
            super.setConcurrency(concurrency);
        }
    }
    
    @Override
    public SQLXML getSQLXML(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public SQLXML getSQLXML(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public RowId getRowId(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public RowId getRowId(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateRowId(int n, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateRowId(String s, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public int getHoldability() throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public boolean isClosed() throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNString(int n, String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNString(String s, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(int n, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(String s, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public NClob getNClob(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public NClob getNClob(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public <T> T unwrap(Class<T> clazz) throws SQLException {
        return null;
    }
    
    @Override
    public boolean isWrapperFor(Class<?> clazz) throws SQLException {
        return false;
    }
    
    @Override
    public void setSQLXML(int n, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setSQLXML(String s, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setRowId(int n, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setRowId(String s, RowId rowId) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNString(int n, String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(String s, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public Reader getNCharacterStream(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public Reader getNCharacterStream(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateSQLXML(int n, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateSQLXML(String s, SQLXML sqlxml) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public String getNString(int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public String getNString(String s) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(int n, InputStream inputStream, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(String s, InputStream inputStream, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBlob(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateNClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBinaryStream(int n, InputStream inputStream, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateAsciiStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBinaryStream(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateBinaryStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void updateCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setURL(int n, URL url) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNClob(int n, NClob nClob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNString(String s, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTimestamp(String s, Timestamp timestamp, Calendar calendar) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(String s, Reader reader, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(String s, Clob clob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setDate(String s, Date date) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setDate(String s, Date date, Calendar calendar) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTime(String s, Time time) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTime(String s, Time time, Calendar calendar) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(int n, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setClob(int n, Reader reader, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(int n, InputStream inputStream, long n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(int n, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(String s, InputStream inputStream, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(String s, Blob blob) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBlob(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setObject(String s, Object o, int n, int n2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setObject(String s, Object o, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setObject(String s, Object o) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setAsciiStream(String s, InputStream inputStream, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBinaryStream(String s, InputStream inputStream, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setCharacterStream(String s, Reader reader, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setAsciiStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBinaryStream(String s, InputStream inputStream) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setCharacterStream(String s, Reader reader) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBigDecimal(String s, BigDecimal bigDecimal) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setString(String s, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBytes(String s, byte[] array) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setTimestamp(String s, Timestamp timestamp) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNull(String s, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setNull(String s, int n, String s2) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setBoolean(String s, boolean b) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setByte(String s, byte b) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setShort(String s, short n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setInt(String s, int n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setLong(String s, long n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setFloat(String s, float n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    @Override
    public void setDouble(String s, double n) throws SQLException {
        throw new SQLFeatureNotSupportedException(this.resBundle.handleGetObject("jdbcrowsetimpl.featnotsupp").toString());
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException, ClassNotFoundException {
        objectInputStream.defaultReadObject();
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException ex) {}
    }
    
    @Override
    public <T> T getObject(int n, Class<T> clazz) throws SQLException {
        throw new SQLFeatureNotSupportedException("Not supported yet.");
    }
    
    @Override
    public <T> T getObject(String s, Class<T> clazz) throws SQLException {
        throw new SQLFeatureNotSupportedException("Not supported yet.");
    }
}
